package com.engine.demo.cmd;

import com.alibaba.excel.EasyExcel;
import com.alibaba.excel.ExcelWriter;
import com.alibaba.excel.write.metadata.WriteSheet;
import com.alibaba.fastjson.JSONObject;
import com.engine.common.biz.AbstractCommonCommand;
import com.engine.common.entity.BizLogContext;
import com.engine.core.interceptor.CommandContext;
import com.engine.demo.entity.invoice.Invoice;
import com.engine.demo.entity.travelBorrow.TravelBorrow;
import com.engine.demo.entity.travelBorrow.TravelBorrowDt1;
import com.engine.demo.entity.travelBorrow.TravelBorrowDt2;
import com.engine.demo.entity.travelBorrow.TravelBorrowDt3;
import com.engine.demo.entity.travelReimbur.*;
import com.engine.demo.util.ExportFjUtil;
import net.sf.json.JSONArray;
import org.apache.commons.lang3.StringUtils;
import weaver.conn.RecordSet;
import weaver.file.ImageFileManager;
import weaver.general.BaseBean;
import weaver.general.Util;
import weaver.hrm.User;

import javax.ws.rs.core.Response;
import java.io.*;
import java.nio.charset.StandardCharsets;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;

public class ExportFjZipCmd extends AbstractCommonCommand<Map<String, Object>> {

    BaseBean bb = new BaseBean();

    public ExportFjZipCmd(Map<String, Object> params, User user) {
        this.user = user;
        this.params = params;
    }

    @Override
    public BizLogContext getLogContext() {
        return null;
    }

    @Override
    public Map<String, Object> execute(CommandContext commandContext) {
        Map<String, Object> result = new HashMap<>();
        RecordSet rs = new RecordSet();
        BaseBean bb = new BaseBean();
        bb.writeLog("========开始下载=========");

        String dataId = Util.null2String(params.get("dataId"));
        bb.writeLog("dataId:" + dataId);
        String type = Util.null2String(params.get("type"));
        bb.writeLog("type:" + type);
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
        String format = sdf.format(new Date());

        //文件生成路径
        String BASE_DIR = "/opt/weaver/ecology/filesystem/ebusecexport";
        bb.writeLog("BASE_DIR:" + BASE_DIR);
        //文件生成名称
        String outPath = "";
        ExportFjUtil util = new ExportFjUtil();
        //从建模中获取需要导出的附件
        List<Map<String, String>> outFiles = new ArrayList<>();
        Map<String, String> lcbhAndWjids = new HashMap<>();

        if ("TravelBorrow".equals(type)) {
            String timeName = "差旅借款导出" + format;
            util.exportExcel(type, dataId, BASE_DIR + File.separator + timeName, File.separator + timeName);
            outPath = BASE_DIR + File.separator + timeName;
            lcbhAndWjids.put(outPath, BASE_DIR + File.separator + timeName + "_" + File.separator + timeName);
            outFiles.add(lcbhAndWjids);
        }

        if ("Invoice".equals(type)) {//发票
            String acqFjSql = " SELECT fpdm, fjid FROM uf_LC_fpxx where id in (" + dataId + ") GROUP BY fpdm, fjid";
            rs.executeQuery(acqFjSql);
            while (rs.next()) {
                String fpdm = Util.null2String(rs.getString("fpdm"));
                String fjid = Util.null2String(rs.getString("fjid"));
                if (StringUtils.isNotBlank(fpdm) && StringUtils.isNotBlank(fjid)) {
                    String timeName = "发票信息导出" + format;
                    String BASE_DIR_NAME = BASE_DIR + File.separator + timeName;
                    bb.writeLog("BASE_DIR_NAME:" + BASE_DIR_NAME);
                    outPath = util.zipDoc(fjid, BASE_DIR_NAME, fpdm + "_" + fjid, "uf_LC_fpxx", "wjcclj", "fjid");
                    bb.writeLog("outPath:" + outPath);
                    lcbhAndWjids.put(outPath, BASE_DIR_NAME + "_" + File.separator + timeName);
                    outFiles.add(lcbhAndWjids);
                }
            }
        }
        if ("TravelReimbur".equals(type)) {//差旅报销
            String acqFjSql = " SELECT b.djbh, string_agg(a.wjid, ',') AS wjids FROM uf_OA_clbxd_dt7 a " +
                    " left join uf_OA_clbxd b " +
                    " on b.id = a.mainid where a.mainid in (" + dataId + ") GROUP BY b.djbh";

            rs.executeQuery(acqFjSql);
            while (rs.next()) {
                String lcbh = Util.null2String(rs.getString("djbh"));
                String wjid = Util.null2String(rs.getString("wjids"));
                if (StringUtils.isNotBlank(lcbh) && StringUtils.isNotBlank(wjid)) {
                    String timeName = "差旅报销导出" + format;
                    String BASE_DIR_NAME = BASE_DIR + File.separator + timeName;
                    bb.writeLog("BASE_DIR_NAME:" + BASE_DIR_NAME);
                    outPath = util.zipDoc(wjid, BASE_DIR_NAME, lcbh + "_" + wjid, "uf_OA_clbxd_dt7", "wjcclj", "wjid");
                    bb.writeLog("outPath:" + outPath);
                    lcbhAndWjids.put(outPath, BASE_DIR_NAME + "_" + File.separator + timeName);
                    outFiles.add(lcbhAndWjids);
                }
            }
        }

        if (!outFiles.isEmpty()) {
            bb.writeLog("outFiles:" + outFiles);
            try {

                for (Map<String, String> outFile : outFiles) {
                    for (String key : outFile.keySet()) {
                        String value = outFile.get(key);
                        String[] split = value.split("_");

                        //先将excel放到文件夹中
                        util.exportExcel(type, dataId, split[0], split[1]);

                        util.zipFolder(split[0], BASE_DIR + File.separator + format);
                    }
                }

                result.put("code", 200);
                result.put("data", "/filesystem/ebusecexport/" + format);
            } catch (Exception e) {
                bb.writeLog("Response Exception: " + e);
                result.put("code", "500");
                result.put("msg", "请求失败，请联系管理员");
                return result;
            }

        } else {
            result.put("code", "500");
            result.put("msg", "请求失败，请联系管理员");
            return result;
        }

        return result;
    }

}
