package com.engine.demo.cmd;

import com.alibaba.excel.EasyExcel;
import com.alibaba.excel.ExcelWriter;
import com.alibaba.excel.write.metadata.WriteSheet;
import com.alibaba.fastjson.JSONObject;
import com.engine.common.biz.AbstractCommonCommand;
import com.engine.common.entity.BizLogContext;
import com.engine.core.interceptor.CommandContext;
import com.engine.demo.entity.FillData;
import com.engine.demo.entity.invoice.Invoice;
import com.engine.demo.entity.travelBorrow.TravelBorrow;
import com.engine.demo.entity.travelBorrow.TravelBorrowDt1;
import com.engine.demo.entity.travelBorrow.TravelBorrowDt2;
import com.engine.demo.entity.travelBorrow.TravelBorrowDt3;
import com.engine.demo.entity.travelReimbur.*;
import com.engine.workflow.biz.RobotNode.RobotNodeBiz;
import com.engine.workflow.biz.RobotNode.RobotNodeServiceBiz;
import com.engine.workflow.biz.requestList.RequestListBiz;
import org.apache.commons.lang3.StringUtils;
import weaver.conn.RecordSet;
import weaver.crm.Maint.CustomerInfoComInfo;
import weaver.general.BaseBean;
import weaver.general.GCONST;
import weaver.general.Util;
import weaver.hrm.User;
import weaver.hrm.resource.ResourceComInfo;

import java.io.File;
import java.lang.reflect.Type;
import java.text.SimpleDateFormat;
import java.util.*;

public class WorkflowExcelDataCmd extends AbstractCommonCommand<Map<String, Object>> {

    BaseBean bb = new BaseBean();

    public WorkflowExcelDataCmd(Map<String, Object> params, User user) {
        this.user = user;
        this.params = params;
    }

    @Override
    public BizLogContext getLogContext() {
        return null;
    }

    @Override
    public Map<String, Object> execute(CommandContext commandContext) {

        Map<String, Object> result = new HashMap<>();

        Map<String, List<List<?>> > exportDatas = new HashMap<>();

        String type = Util.null2String(params.get("type"));
        String dataIds = Util.null2String(params.get("dataIds"));

        if (StringUtils.isBlank(type)) {
            result.put("code","500");
            result.put("msg","先选择要导出类型");
            return result;
        }
        if (StringUtils.isBlank(dataIds)) {
            result.put("code","500");
            result.put("msg","先选择要导出数据");
            return result;
        }

        //封装数据
        try {

            RecordSet rs = new RecordSet();
            String tableName = "";
            if ("TravelBorrow".equals(type)) {//差旅借款
                tableName = "uf_LC_cljkd";
//                tableName = "formtable_main_24";
                String acqDataSql = "select a.*, b.*, c. * ,d.* from " + tableName + " a " +
                        " left join " + tableName + "_dt1 b" +
                        " on b.mainid = a.id " +
                        " left join " + tableName + "_dt2 c" +
                        " on c.mainid = a.id " +
                        " left join " + tableName + "_dt3 d" +
                        " on d.mainid = a.id " +
                        "where a.id in (" + dataIds + ")";
                bb.writeLog("TravelBorrow acqDataSql: " + acqDataSql);
                List<List<?>> datasList = new ArrayList<>();
                rs.executeQuery(acqDataSql);
                List dataList = new ArrayList<>();
                List data1List = new ArrayList<>();
                List data2List = new ArrayList<>();
                List data3List = new ArrayList<>();
                while (rs.next()) {

                    //主表
                    TravelBorrow travelBorrow = new TravelBorrow();
                    travelBorrow.setDjmc(Util.null2String(rs.getString("djmc")));
                    travelBorrow.setDjbh(Util.null2String(rs.getString("djbh")));
                    travelBorrow.setJkdwbh(Util.null2String(rs.getString("jkdwbh")));
                    travelBorrow.setBmbh(Util.null2String(rs.getString("bmbh")));
                    travelBorrow.setDjzt(Util.null2String(rs.getString("djzt")));
                    travelBorrow.setJkrbh(Util.null2String(rs.getString("jkrbh")));
                    travelBorrow.setDjrq(Util.null2String(rs.getString("djrq")));
                    travelBorrow.setFyxmbh(Util.null2String(rs.getString("fyxmbh")));
                    travelBorrow.setFjzs(Util.null2String(rs.getString("fjzs")));
                    travelBorrow.setKyxmmc(Util.null2String(rs.getString("kyxmmc")));
                    travelBorrow.setRyzw(Util.null2String(rs.getString("ryzw")));
                    travelBorrow.setRyzwbh(Util.null2String(rs.getString("ryzwbh")));
                    travelBorrow.setZyxx(Util.null2String(rs.getString("zyxx")));
                    travelBorrow.setSqje(Util.null2String(rs.getString("sqje")));
                    travelBorrow.setBxycxsqje(Util.null2String(rs.getString("bxycxsqje")));
                    travelBorrow.setJkje(Util.null2String(rs.getString("jkje")));
                    travelBorrow.setZdrbh(Util.null2String(rs.getString("zdrbh")));
                    travelBorrow.setSfwt(Util.null2String(rs.getString("sfwt")));
                    dataList.add(travelBorrow);
                    //明细表1
                    TravelBorrowDt1 travelBorrowDt1 = new TravelBorrowDt1();
                    travelBorrowDt1.setNm(Util.null2String(rs.getString("nm")));
                    travelBorrowDt1.setJkdnm(Util.null2String(rs.getString("jkdnm")));
                    travelBorrowDt1.setSqdh(Util.null2String(rs.getString("sqdh")));
                    travelBorrowDt1.setSqsm(Util.null2String(rs.getString("sqsm")));
                    travelBorrowDt1.setCcksrq(Util.null2String(rs.getString("ccksrq")));
                    travelBorrowDt1.setCcjsrq(Util.null2String(rs.getString("ccjsrq")));
                    data1List.add(travelBorrowDt1);
                    //明细表2
                    TravelBorrowDt2 travelBorrowDt2 = new TravelBorrowDt2();
                    travelBorrowDt2.setFkjlnm(Util.null2String(rs.getString("fkjlnm")));
                    travelBorrowDt2.setBzdnm(Util.null2String(rs.getString("bzdnm")));
                    travelBorrowDt2.setZjjhbh(Util.null2String(rs.getString("zjjhbh")));
                    travelBorrowDt2.setZffsbh(Util.null2String(rs.getString("zffsbh")));
                    travelBorrowDt2.setDfxz(Util.null2String(rs.getString("dfxz")));
                    travelBorrowDt2.setBzrdw(Util.null2String(rs.getString("bzrdw")));
                    travelBorrowDt2.setSkzhm(Util.null2String(rs.getString("skzhm")));
                    travelBorrowDt2.setFkje(Util.null2String(rs.getString("fkje")));
                    travelBorrowDt2.setYxzh(Util.null2String(rs.getString("yxzh")));
                    travelBorrowDt2.setKhyx(Util.null2String(rs.getString("khyx")));
                    travelBorrowDt2.setZfsm(Util.null2String(rs.getString("zfsm")));
                    travelBorrowDt2.setZt(Util.null2String(rs.getString("zt")));
                    travelBorrowDt2.setFkhbbh(Util.null2String(rs.getString("fkhbbh")));
                    data2List.add(travelBorrowDt2);
                    //明细表3
                    TravelBorrowDt3 travelBorrowDt3 = new TravelBorrowDt3();
                    travelBorrowDt3.setJkdnm(Util.null2String(rs.getString("jkdnm")));
                    travelBorrowDt3.setSpjd(Util.null2String(rs.getString("spjd")));
                    travelBorrowDt3.setSpr(Util.null2String(rs.getString("spr")));
                    travelBorrowDt3.setSpnr(Util.null2String(rs.getString("spnr")));
                    travelBorrowDt3.setSpsj(Util.null2String(rs.getString("spsj")));
                    data3List.add(travelBorrowDt3);
                }
                datasList.add(dataList);
                datasList.add(data1List);
                datasList.add(data2List);
                datasList.add(data3List);
                exportDatas.put(type, datasList);
            }

            if ("Invoice".equals(type)) {//发票
                tableName = "uf_LC_fpxx";
                String acqDataSql = "select a.* from " + tableName + " a where a.id in (" + dataIds + ")";
                bb.writeLog("Invoice acqDataSql: " + acqDataSql);
                List<List<?>> datasList = new ArrayList<>();
                rs.executeQuery(acqDataSql);
                List dataList = new ArrayList<>();
                while (rs.next()) {
                    //主表
                    Invoice invoice = new Invoice();
                    invoice.setFpzj(Util.null2String(rs.getString("a.fpzj")));
                    invoice.setFplxid(Util.null2String(rs.getString("a.fplxid")));
                    invoice.setFplxbh(Util.null2String(rs.getString("a.fplxbh")));
                    invoice.setFpzlbh(Util.null2String(rs.getString("a.fpzlbh")));
                    invoice.setGmfmc(Util.null2String(rs.getString("a.gmfmc")));
                    invoice.setGmfxxnsrsbh(Util.null2String(rs.getString("a.gmfxxnsrsbh")));
                    invoice.setGmfxxdz(Util.null2String(rs.getString("a.gmfxxdz")));
                    invoice.setGmfxxdh(Util.null2String(rs.getString("a.gmfxxdh")));
                    invoice.setGmfxxkhx(Util.null2String(rs.getString("a.gmfxxkhx")));
                    invoice.setGmfxxkhxzh(Util.null2String(rs.getString("a.gmfxxkhxzh")));
                    invoice.setXsfmc(Util.null2String(rs.getString("a.xsfmc")));
                    invoice.setXsfxxnssbh(Util.null2String(rs.getString("a.xsfxxnssbh")));
                    invoice.setXsfdz(Util.null2String(rs.getString("a.xsfdz")));
                    invoice.setXsfdh(Util.null2String(rs.getString("a.xsfdh")));
                    invoice.setXsfkhyx(Util.null2String(rs.getString("a.xsfkhyx")));
                    invoice.setXsfkhxzh(Util.null2String(rs.getString("a.xsfkhxzh")));
                    invoice.setXym(Util.null2String(rs.getString("a.xym")));
                    invoice.setFphm(Util.null2String(rs.getString("a.fphm")));
                    invoice.setFpdm(Util.null2String(rs.getString("a.fpdm")));
                    invoice.setFprq(Util.null2String(rs.getString("a.fprq")));
                    invoice.setFpje(Util.null2String(rs.getString("a.fpje")));
                    invoice.setBhse(Util.null2String(rs.getString("a.bhse")));
                    invoice.setSe(Util.null2String(rs.getString("a.se")));
                    invoice.setBz(Util.null2String(rs.getString("a.bz")));
                    invoice.setFpbq(Util.null2String(rs.getString("a.fpbq")));
                    invoice.setFpfl(Util.null2String(rs.getString("a.fpfl")));
                    invoice.setFpflmc(Util.null2String(rs.getString("a.fpflmc")));
                    invoice.setFpnr(Util.null2String(rs.getString("a.fpnr")));
                    invoice.setYzzt(Util.null2String(rs.getString("a.yzzt")));
                    invoice.setBxzt(Util.null2String(rs.getString("a.bxzt")));
                    invoice.setZh(Util.null2String(rs.getString("a.zh")));
                    invoice.setDwbh(Util.null2String(rs.getString("a.dwbh")));
                    invoice.setYgbh(Util.null2String(rs.getString("a.ygbh")));
                    invoice.setWjlx(Util.null2String(rs.getString("a.wjlx")));
                    invoice.setCjsj(Util.null2String(rs.getString("a.cjsj")));
                    invoice.setCjr(Util.null2String(rs.getString("a.cjr")));
                    invoice.setZhxgsj(Util.null2String(rs.getString("a.zhxgsj")));
                    invoice.setZhxgr(Util.null2String(rs.getString("a.zhxgr")));
                    invoice.setYxlj(Util.null2String(rs.getString("a.yxlj")));
                    invoice.setSfzy(Util.null2String(rs.getString("a.sfzy")));
                    invoice.setZyrbh(Util.null2String(rs.getString("a.zyrbh")));

                    dataList.add(invoice);

                    datasList.add(dataList);
                }
                exportDatas.put(type, datasList);
            }
            if ("TravelReimbur".equals(type)) {//差旅报销
                tableName = "uf_OA_clbxd";
                String acqDataSql = "select a.*, b.*, c. * ,d.*, e.*, f.*, g.*, h.* from " + tableName + " a " +
                        " left join " + tableName + "_dt1 b" +
                        " on b.mainid = a.id " +
                        " left join " + tableName + "_dt2 c" +
                        " on c.mainid = a.id " +
                        " left join " + tableName + "_dt3 d" +
                        " on d.mainid = a.id " +
                        " left join " + tableName + "_dt4 e" +
                        " on e.mainid = a.id " +
                        " left join " + tableName + "_dt5 f" +
                        " on f.mainid = a.id " +
                        " left join " + tableName + "_dt6 g" +
                        " on g.mainid = a.id " +
                        " left join " + tableName + "_dt7 h" +
                        " on h.mainid = a.id " +
                        "where a.id in (" + dataIds + ")";
                bb.writeLog("TravelReimbur acqDataSql: " + acqDataSql);
                List<List<?>> datasList = new ArrayList<>();
                rs.executeQuery(acqDataSql);
                List dataList = new ArrayList<>();
                List data1List = new ArrayList<>();
                List data2List = new ArrayList<>();
                List data3List = new ArrayList<>();
                List data4List = new ArrayList<>();
                List data5List = new ArrayList<>();
                List data6List = new ArrayList<>();
                List data7List = new ArrayList<>();
                while (rs.next()) {
                    //主表
                    TravelReimbur travelReimbur = new TravelReimbur();
                    travelReimbur.setDjmc(Util.null2String(rs.getString("a.djmc")));
                    travelReimbur.setDjbh(Util.null2String(rs.getString("a.djbh")));
                    travelReimbur.setDwbh(Util.null2String(rs.getString("a.dwbh")));
                    travelReimbur.setBmbh(Util.null2String(rs.getString("a.bmbh")));
                    travelReimbur.setDjzt(Util.null2String(rs.getString("a.djzt")));
                    travelReimbur.setBxrybh(Util.null2String(rs.getString("a.bxrybh")));
                    travelReimbur.setRyzw(Util.null2String(rs.getString("a.ryzw")));
                    travelReimbur.setRyzwbh(Util.null2String(rs.getString("a.ryzwbh")));
                    travelReimbur.setRyzjid(Util.null2String(rs.getString("a.ryzjid")));
                    travelReimbur.setRyzj(Util.null2String(rs.getString("a.ryzj")));
                    travelReimbur.setCclx(Util.null2String(rs.getString("a.cclx")));
                    travelReimbur.setCcdd(Util.null2String(rs.getString("a.ccdd")));
                    travelReimbur.setCcksrq(Util.null2String(rs.getString("a.ccksrq")));
                    travelReimbur.setCcjsrq(Util.null2String(rs.getString("a.ccjsrq")));
                    travelReimbur.setCcts(Util.null2String(rs.getString("a.ccts")));
                    travelReimbur.setXmmc(Util.null2String(rs.getString("a.xmmc")));
                    travelReimbur.setHsxmlb(Util.null2String(rs.getString("a.hsxmlb")));
                    travelReimbur.setKdkse(Util.null2String(rs.getString("a.kdkse")));
                    travelReimbur.setFjzs(Util.null2String(rs.getString("a.fjzs")));
                    travelReimbur.setLxdh(Util.null2String(rs.getString("a.lxdh")));
                    travelReimbur.setBzje(Util.null2String(rs.getString("a.bzje")));
                    travelReimbur.setFyrq(Util.null2String(rs.getString("a.fyrq")));
                    travelReimbur.setSfczcbfy(Util.null2String(rs.getString("a.sfczcbfy")));
                    travelReimbur.setCcsy(Util.null2String(rs.getString("a.ccsy")));
                    travelReimbur.setSbje(Util.null2String(rs.getString("a.sbje")));
                    travelReimbur.setSfje(Util.null2String(rs.getString("a.sfje")));
                    travelReimbur.setJhje(Util.null2String(rs.getString("a.jhje")));
                    travelReimbur.setFyxmnm(Util.null2String(rs.getString("a.fyxmnm")));
                    travelReimbur.setZdrbh(Util.null2String(rs.getString("a.zdrbh")));
                    travelReimbur.setSfwt(Util.null2String(rs.getString("a.sfwt")));
                    travelReimbur.setStr(Util.null2String(rs.getString("a.str")));
                    dataList.add(travelReimbur);
                    //明细表1
                    TravelReimburDt1 travelReimburDt1 = new TravelReimburDt1();
                    travelReimburDt1.setBxdnm(Util.null2String(rs.getString("b.bxdnm")));
                    travelReimburDt1.setCfcs(Util.null2String(rs.getString("b.cfcs")));
                    travelReimburDt1.setCfrq(Util.null2String(rs.getString("b.cfrq")));
                    travelReimburDt1.setJtgj(Util.null2String(rs.getString("b.jtgj")));
                    travelReimburDt1.setZxdj(Util.null2String(rs.getString("b.zxdj")));
                    travelReimburDt1.setCchbc(Util.null2String(rs.getString("b.cchbc")));
                    travelReimburDt1.setJpzk(Util.null2String(rs.getString("b.jpzk")));
                    travelReimburDt1.setDdcs(Util.null2String(rs.getString("b.ddcs")));
                    travelReimburDt1.setDdrq(Util.null2String(rs.getString("b.ddrq")));
                    travelReimburDt1.setCcts(Util.null2String(rs.getString("b.ccts")));
                    travelReimburDt1.setCcf(Util.null2String(rs.getString("b.ccf")));
                    travelReimburDt1.setZsfbz(Util.null2String(rs.getString("b.zsfbz")));
                    travelReimburDt1.setZsts(Util.null2String(rs.getString("b.zsts")));
                    travelReimburDt1.setZsf(Util.null2String(rs.getString("b.zsf")));
                    travelReimburDt1.setZsfsfcb(Util.null2String(rs.getString("b.zsfsfcb")));
                    travelReimburDt1.setZscbsm(Util.null2String(rs.getString("b.zscbsm")));
                    travelReimburDt1.setBxjhsjcf(Util.null2String(rs.getString("b.bxjhsjcf")));
                    travelReimburDt1.setQtcbfy(Util.null2String(rs.getString("b.qtcbfy")));
                    travelReimburDt1.setCbfysm(Util.null2String(rs.getString("b.cbfysm")));
                    travelReimburDt1.setBzje(Util.null2String(rs.getString("b.bzje")));
                    travelReimburDt1.setBxje(Util.null2String(rs.getString("b.bxje")));
                    travelReimburDt1.setSfczcbfy2(Util.null2String(rs.getString("b.sfczcbfy2")));
                    data1List.add(travelReimburDt1);
                    //明细表2
                    TravelReimburDt2 travelReimburDt2 = new TravelReimburDt2();
                    travelReimburDt2.setBxdid(Util.null2String(rs.getString("c.bxdid")));
                    travelReimburDt2.setFtdwbh(Util.null2String(rs.getString("c.ftdwbh")));
                    travelReimburDt2.setFtbmbh(Util.null2String(rs.getString("c.ftbmbh")));
                    travelReimburDt2.setFyxm(Util.null2String(rs.getString("c.fyxm")));
                    travelReimburDt2.setFyxmbh(Util.null2String(rs.getString("c.fyxmbh")));
                    travelReimburDt2.setFtje(Util.null2String(rs.getString("c.ftje")));
                    travelReimburDt2.setFtsm(Util.null2String(rs.getString("c.ftsm")));
                    travelReimburDt2.setFph(Util.null2String(rs.getString("c.fph")));
                    data2List.add(travelReimburDt2);
                    //明细表3
                    TravelReimburDt3 travelReimburDt3 = new TravelReimburDt3();
                    travelReimburDt3.setBxnm(Util.null2String(rs.getString("d.bxnm")));
                    travelReimburDt3.setSqdjbh(Util.null2String(rs.getString("d.sqdjbh")));
                    travelReimburDt3.setCcksrq(Util.null2String(rs.getString("d.ccksrq")));
                    travelReimburDt3.setCcjsrq(Util.null2String(rs.getString("d.ccjsrq")));
                    data3List.add(travelReimburDt3);
                    //明细表4
                    TravelReimburDt4 travelReimburDt4 = new TravelReimburDt4();
                    travelReimburDt4.setHxdjnm(Util.null2String(rs.getString("e.hxdjnm")));
                    travelReimburDt4.setJkrq(Util.null2String(rs.getString("e.jkrq")));
                    travelReimburDt4.setDjbh(Util.null2String(rs.getString("e.djbh")));
                    travelReimburDt4.setJklx(Util.null2String(rs.getString("e.jklx")));
                    travelReimburDt4.setFyxm(Util.null2String(rs.getString("e.fyxm")));
                    travelReimburDt4.setJksm(Util.null2String(rs.getString("e.jksm")));
                    travelReimburDt4.setJkje(Util.null2String(rs.getString("e.jkje")));
                    travelReimburDt4.setZthk(Util.null2String(rs.getString("e.zthk")));
                    travelReimburDt4.setYhk(Util.null2String(rs.getString("e.yhk")));
                    travelReimburDt4.setHxje(Util.null2String(rs.getString("e.hxje")));
                    travelReimburDt4.setXjhk(Util.null2String(rs.getString("e.xjhk")));
                    travelReimburDt4.setQk(Util.null2String(rs.getString("e.qk")));
                    data4List.add(travelReimburDt4);
                    //明细表5
                    TravelReimburDt5 travelReimburDt5 = new TravelReimburDt5();
                    travelReimburDt5.setFkjlnm(Util.null2String(rs.getString("f.fkjlnm")));
                    travelReimburDt5.setBzdnm(Util.null2String(rs.getString("f.bzdnm")));
                    travelReimburDt5.setZjjhbh(Util.null2String(rs.getString("f.zjjhbh")));
                    travelReimburDt5.setZjjhjsxz(Util.null2String(rs.getString("f.zjjhjsxz")));
                    travelReimburDt5.setZffsbh(Util.null2String(rs.getString("f.zffsbh")));
                    travelReimburDt5.setDfxz(Util.null2String(rs.getString("f.dfxz")));
                    travelReimburDt5.setDwlb(Util.null2String(rs.getString("f.dwlb")));
                    travelReimburDt5.setBzrdw(Util.null2String(rs.getString("f.bzrdw")));
                    travelReimburDt5.setFkhbbh(Util.null2String(rs.getString("f.fkhbbh")));
                    travelReimburDt5.setSkzhm(Util.null2String(rs.getString("f.skzhm")));
                    travelReimburDt5.setFkje(Util.null2String(rs.getString("f.fkje")));
                    travelReimburDt5.setKhyx(Util.null2String(rs.getString("f.khyx")));
                    travelReimburDt5.setYxzh(Util.null2String(rs.getString("f.yxzh")));
                    travelReimburDt5.setSsf(Util.null2String(rs.getString("f.ssf")));
                    travelReimburDt5.setScs(Util.null2String(rs.getString("f.scs")));
                    travelReimburDt5.setFksm(Util.null2String(rs.getString("f.fksm")));
                    travelReimburDt5.setZt(Util.null2String(rs.getString("f.zt")));
                    travelReimburDt5.setSkyxlxh(Util.null2String(rs.getString("f.skyxlxh")));
                    travelReimburDt5.setGssfdf(Util.null2String(rs.getString("f.gssfdf")));
                    travelReimburDt5.setGsdf(Util.null2String(rs.getString("f.gsdf")));
                    data5List.add(travelReimburDt5);
                    //明细表6
                    TravelReimburDt6 travelReimburDt6 = new TravelReimburDt6();
                    travelReimburDt6.setBxdid(Util.null2String(rs.getString("g.bxdid")));
                    travelReimburDt6.setSpjd(Util.null2String(rs.getString("g.spjd")));
                    travelReimburDt6.setSprbh(Util.null2String(rs.getString("g.sprbh")));
                    travelReimburDt6.setSpnr(Util.null2String(rs.getString("g.spnr")));
                    travelReimburDt6.setSpsj(Util.null2String(rs.getString("g.spsj")));
                    data6List.add(travelReimburDt6);
                    //明细表6
                    TravelReimburDt7 travelReimburDt7 = new TravelReimburDt7();
                    travelReimburDt7.setWjid(Util.null2String(rs.getString("h.wjid")));
                    travelReimburDt7.setDjnm(Util.null2String(rs.getString("h.djnm")));
                    travelReimburDt7.setWjmc(Util.null2String(rs.getString("h.wjmc")));
                    travelReimburDt7.setWjlx(Util.null2String(rs.getString("h.wjlx")));
                    travelReimburDt7.setWjdx(Util.null2String(rs.getString("h.wjdx")));
                    travelReimburDt7.setWjcclj(Util.null2String(rs.getString("h.wjcclj")));
                    data7List.add(travelReimburDt7);
                }
                datasList.add(dataList);
                datasList.add(data1List);
                datasList.add(data2List);
                datasList.add(data3List);
                datasList.add(data4List);
                datasList.add(data5List);
                datasList.add(data6List);
                datasList.add(data7List);
                exportDatas.put(type, datasList);
            }
            bb.writeLog("exportDatas: " + JSONObject.toJSONString(exportDatas));

            SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
            String fileName="/opt/weaver/ecology/filesystem/ebusecexport/"+ "差旅借款单" + sdf.format(new Date()) + ".xlsx";
            exportExcel(fileName, exportDatas);
            result.put("code",200);
            result.put("msg",fileName);
        }catch (Exception e) {
            bb.writeLog("WorkflowExcelDataCmd Exception: " + e);
            result.put("code",500);
            result.put("msg","导出异常，请联系管理员");
        }

        return result;
    }

    public void exportExcel(String fileName, Map<String, List<List<?>> > exportDatas) {

        ExcelWriter excelWriter = EasyExcel.write(fileName).build();
        WriteSheet writeSheet = new WriteSheet();

        for (String key : exportDatas.keySet()) {
            List<List<?>> tempList = exportDatas.get(key);
            int i = 0;
            for (List<?> tl: tempList) {
                //这里 需要指定写用哪个class去写
                writeSheet = EasyExcel.writerSheet(i, "第" + i + "个sheet页").head(tl.get(0).getClass()).build();
                excelWriter.write(tl, writeSheet);
                i++;
            }
        }

        //千万别忘记finish 会帮忙关闭流
        excelWriter.finish();
    }

}
