package com.engine.demo.controller;

import com.engine.common.util.ParamUtil;
import com.engine.common.util.ServiceUtil;
import com.engine.demo.service.WorkflowExcelService;
import com.engine.demo.service.impl.WorkflowExcelServiceImpl;
import com.google.gson.Gson;
import weaver.hrm.HrmUserVarify;
import weaver.hrm.User;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;
import java.util.Map;

public class WorkflowExcelController {

    public WorkflowExcelService getWorkflowExcelService(User user) {
        return ServiceUtil.getService(WorkflowExcelServiceImpl.class,user);
    }

    @GET
    @Path("/getEndWorkDate")
    @Produces(MediaType.APPLICATION_JSON)
    public String getEndWorkDate(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        User user = HrmUserVarify.getUser(request, response);
        Map<String, Object> params = ParamUtil.request2Map(request);
        Map<String, Object> resultDatas = getWorkflowExcelService(user).WorklowBatchExport(params, user);
        return  new Gson().toJson(resultDatas);
    }

    @GET
    @Path("/getWorkflowExcelData")
    @Produces(MediaType.APPLICATION_JSON)
    public String getWorkflowExcelData(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        User user = HrmUserVarify.getUser(request, response);
        Map<String, Object> params = ParamUtil.request2Map(request);
        Map<String, Object> resultDatas = getWorkflowExcelService(user).WorkflowExcelData(params, user);
        return  new Gson().toJson(resultDatas);
    }

    @GET
    @Path("/exportFjZip")
    @Produces(MediaType.APPLICATION_JSON)
    public String exportFjZip(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        User user = HrmUserVarify.getUser(request, response);
        Map<String, Object> params = ParamUtil.request2Map(request);
        Map<String, Object> resultDatas = getWorkflowExcelService(user).exportFjZip(params, user);
        return  new Gson().toJson(resultDatas);
    }

}