/*
 * USER : DYJ
 * DATE : 2023/12/9
 * TIME : 23:10
 * DEMAND ：
 * Design Ideas：
 */
package com.engine.demo.util;

import com.alibaba.excel.EasyExcel;
import com.alibaba.excel.ExcelWriter;
import com.alibaba.excel.write.metadata.WriteSheet;
import com.alibaba.fastjson.JSONObject;
import com.engine.common.util.ServiceUtil;
import com.engine.demo.entity.invoice.Invoice;
import com.engine.demo.entity.travelBorrow.TravelBorrow;
import com.engine.demo.entity.travelBorrow.TravelBorrowDt1;
import com.engine.demo.entity.travelBorrow.TravelBorrowDt2;
import com.engine.demo.entity.travelBorrow.TravelBorrowDt3;
import com.engine.demo.entity.travelReimbur.*;
import com.engine.workflow.service.HtmlToPdfService;
import com.engine.workflow.service.impl.HtmlToPdfServiceImpl;
import weaver.conn.RecordSet;
import weaver.file.ImageFileManager;
import weaver.general.BaseBean;
import weaver.general.Util;
import weaver.hrm.User;
import weaver.workflow.workflow.WorkflowConfigComInfo;

import java.io.*;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;

public class ExportFjUtil {

    BaseBean bb = new BaseBean();

    public String zipDoc(String docIds, String BASE_DIR, String zipFileName, String tableName, String tableField, String whereField) {
        String[] zipFileNames = zipFileName.split("_");
        String outPath = BASE_DIR  + File.separator + "附件" + File.separator + zipFileNames[0]  ;
        bb.writeLog("zipDoc outPath: " + outPath);
        RecordSet rs = new RecordSet();
        File file_ = new File(outPath);
        if (!file_.exists()) {
            boolean mkdirs = file_.mkdirs();
            bb.writeLog("zipDoc mkdirs: " + mkdirs);

        }

        try {
            List<List> filePaths = new ArrayList();
            bb.writeLog("zipDoc outPath: " + outPath + ".zip");
            FileOutputStream fileOutputStream = new FileOutputStream(outPath + ".zip");
            ZipOutputStream zipOutputStream = new ZipOutputStream(fileOutputStream);
            BufferedInputStream br = null;
            //文件的名称
            //循环下载文件，并将之放到ZipOutputStream中
            rs.execute("select imagefilename,imagefileid,docid from docimagefile where docid in (" + docIds + ")");
            bb.writeLog("zipDoc sql: select imagefilename,imagefileid from docimagefile where docid in (" + docIds + ")");
            while (rs.next()) {
                List filePath = new ArrayList();
                filePath.add("附件/" + zipFileNames[0] + "/" +rs.getString(3));
                filePath.add(rs.getString(1));
                filePaths.add(filePath);
                zipOutputStream.putNextEntry(new ZipEntry(rs.getString(1)));
                br = new BufferedInputStream(ImageFileManager.getInputStreamById(rs.getInt(2)));
                byte[] buffer = new byte[1024];
                int r = 0;
                while ((r = br.read(buffer)) != -1) {
                    zipOutputStream.write(buffer, 0, r);
                }
            }

            zipOutputStream.flush();
            zipOutputStream.close();
            br.close();

            //回写附件导出路径   差旅报销导出20240320144153\附件\CS001.zip
            String syncSql = "update " + tableName + " set " + tableField + " = ? where " + whereField + " = ? ";
            rs.executeBatchSql(syncSql, filePaths);

        } catch (IOException e) {
            bb.writeLog("DownloadDocs.zipDoc[" + Thread.currentThread().getStackTrace()[1].getLineNumber() + "] => e.getMessage() = " + e.getMessage());
            e.printStackTrace();
        }

        return outPath;
    }

    public void zipFolder(String folderPath, String zipFilePath) throws IOException {
        File folder = new File(folderPath);
        FileOutputStream fos = new FileOutputStream(zipFilePath + ".zip");
        ZipOutputStream zos = new ZipOutputStream(fos);
        addFolderToZip(folder, folder.getName(), zos);
        zos.close();
        fos.close();
    }

    private void addFolderToZip(File folder, String base, ZipOutputStream zos) throws IOException {
        File[] files = folder.listFiles();
        byte[] buffer = new byte[1024];
        for (File file : files) {
            if (file.isDirectory()) {
                addFolderToZip(file, base + "/" + file.getName(), zos);
            } else {
                FileInputStream fis = new FileInputStream(file);
                ZipEntry zipEntry = new ZipEntry(base + "/" + file.getName());
                zos.putNextEntry(zipEntry);

                int len;
                while ((len = fis.read(buffer)) > 0) {
                    zos.write(buffer, 0, len);
                }

                zos.closeEntry();
                fis.close();
            }
        }
    }


    public boolean exportExcel(String type , String dataIds, String outPath , String fileName){
        boolean result = false;
        Map<String, List<List<?>> > exportDatas = new HashMap<>();

        //封装数据
        try {

            RecordSet rs = new RecordSet();
            String tableName = "";
            if ("TravelBorrow".equals(type)) {//差旅借款
                tableName = "uf_LC_cljkd";
//                String acqDataSql = "select a.*, b.*, c. * ,d.* " +
                String acqDataSql = "select " +
                        " a.id as a_id,  \n" +
                        "a.requestid as a_requestid,  \n" +
                        "a.djmc as a_djmc,  \n" +
                        "a.djbh as a_djbh,  \n" +
                        "a.jkdwbh as a_jkdwbh,  \n" +
                        "a.bmbh as a_bmbh,  \n" +
                        "a.djzt as a_djzt,  \n" +
                        "a.jkrbh as a_jkrbh,  \n" +
                        "a.djrq as a_djrq,  \n" +
                        "a.fyxmbh as a_fyxmbh,  \n" +
                        "a.fjzs as a_fjzs,  \n" +
                        "a.kyxmmc as a_kyxmmc,  \n" +
                        "a.ryzw as a_ryzw,  \n" +
                        "a.ryzwbh as a_ryzwbh,  \n" +
                        "a.zyxx as a_zyxx,  \n" +
                        "a.sqje as a_sqje,  \n" +
                        "a.bxycxsqje as a_bxycxsqje,  \n" +
                        "a.jkje as a_jkje,  \n" +
                        "a.zdrbh as a_zdrbh,  \n" +
                        "a.sfwt as a_sfwt,  \n" +
                        "a.str as a_str,  \n" +
                        "a.formmodeid as a_formmodeid,  \n" +
                        "a.modedatacreater as a_modedatacreater,  \n" +
                        "a.modedatacreatertype as a_modedatacreatertype,  \n" +
                        "a.modedatacreatedate as a_modedatacreatedate,  \n" +
                        "a.modedatacreatetime as a_modedatacreatetime,  \n" +
                        "a.modedatamodifier as a_modedatamodifier,  \n" +
                        "a.modedatamodifydatetime as a_modedatamodifydatetime,  \n" +
                        "a.form_biz_id as a_form_biz_id,  \n" +
                        "a.modeuuid as a_modeuuid,  \n" +
                        "a.yslcid as a_yslcid,  \n" +
                        "a.dczt as a_dczt,  \n" +
                        "  \n" +
                        "b.id as b_id,  \n" +
                        "b.mainid as b_mainid,  \n" +
                        "b.nm as b_nm,  \n" +
                        "b.jkdnm as b_jkdnm,  \n" +
                        "b.sqdh as b_sqdh,  \n" +
                        "b.sqsm as b_sqsm,  \n" +
                        "b.ccksrq as b_ccksrq,  \n" +
                        "b.ccjsrq as b_ccjsrq,  \n" +
                        "b.yslcmxid as b_yslcmxid,  \n" +
                        "  \n" +
                        "c.id as c_id,  \n" +
                        "c.mainid as c_mainid,  \n" +
                        "c.fkjlnm as c_fkjlnm,  \n" +
                        "c.bzdnm as c_bzdnm,  \n" +
                        "c.zjjhbh as c_zjjhbh,  \n" +
                        "c.zffsbh as c_zffsbh,  \n" +
                        "c.dfxz as c_dfxz,  \n" +
                        "c.bzrdw as c_bzrdw,  \n" +
                        "c.skzhm as c_skzhm,  \n" +
                        "c.fkje as c_fkje,  \n" +
                        "c.yxzh as c_yxzh,  \n" +
                        "c.khyx as c_khyx,  \n" +
                        "c.zfsm as c_zfsm,  \n" +
                        "c.zt as c_zt,  \n" +
                        "c.fkhbbh as c_fkhbbh,  \n" +
                        "c.yslcmxid as c_yslcmxid,  \n" +
                        "  \n" +
                        "d.id as d_id,  \n" +
                        "d.mainid as d_mainid,  \n" +
                        "d.jkdnm as d_jkdnm,  \n" +
                        "d.spjd as d_spjd,  \n" +
                        "d.spr as d_spr,  \n" +
                        "d.spnr as d_spnr,  \n" +
                        "d.spsj as d_spsj,  \n" +
                        "d.yslcmxid as d_yslcmxid" +
                        " from " + tableName + " a " +
                        " left join " + tableName + "_dt1 b" +
                        " on b.mainid = a.id " +
                        " left join " + tableName + "_dt2 c" +
                        " on c.mainid = a.id " +
                        " left join " + tableName + "_dt3 d" +
                        " on d.mainid = a.id " +
                        "where a.id in (" + dataIds + ")";
                bb.writeLog("TravelBorrow acqDataSql: " + acqDataSql);
                List<List<?>> datasList = new ArrayList<>();
                rs.executeQuery(acqDataSql);
                List dataList = new ArrayList<>();
                List data1List = new ArrayList<>();
                List data2List = new ArrayList<>();
                List data3List = new ArrayList<>();
                while (rs.next()) {

                    //主表
                    TravelBorrow travelBorrow = new TravelBorrow();
                    travelBorrow.setDjmc(Util.null2String(rs.getString("a_djmc")));
                    travelBorrow.setDjbh(Util.null2String(rs.getString("a_djbh")));
                    travelBorrow.setJkdwbh(Util.null2String(rs.getString("a_jkdwbh")));
                    travelBorrow.setBmbh(Util.null2String(rs.getString("a_bmbh")));
                    travelBorrow.setDjzt(Util.null2String(rs.getString("a_djzt")));
                    travelBorrow.setJkrbh(Util.null2String(rs.getString("a_jkrbh")));
                    travelBorrow.setDjrq(Util.null2String(rs.getString("a_djrq")));
                    travelBorrow.setFyxmbh(Util.null2String(rs.getString("a_fyxmbh")));
                    travelBorrow.setFjzs(Util.null2String(rs.getString("a_fjzs")));
                    travelBorrow.setKyxmmc(Util.null2String(rs.getString("a_kyxmmc")));
                    travelBorrow.setRyzw(Util.null2String(rs.getString("a_ryzw")));
                    travelBorrow.setRyzwbh(Util.null2String(rs.getString("a_ryzwbh")));
                    travelBorrow.setZyxx(Util.null2String(rs.getString("a_zyxx")));
                    travelBorrow.setSqje(Util.null2String(rs.getString("a_sqje")));
                    travelBorrow.setBxycxsqje(Util.null2String(rs.getString("a_bxycxsqje")));
                    travelBorrow.setJkje(Util.null2String(rs.getString("a_jkje")));
                    travelBorrow.setZdrbh(Util.null2String(rs.getString("a_zdrbh")));
                    travelBorrow.setSfwt(Util.null2String(rs.getString("a_sfwt")));
                    dataList.add(travelBorrow);
                    //明细表1
                    TravelBorrowDt1 travelBorrowDt1 = new TravelBorrowDt1();
                    travelBorrowDt1.setNm(Util.null2String(rs.getString("b_nm")));
                    travelBorrowDt1.setJkdnm(Util.null2String(rs.getString("b_jkdnm")));
                    travelBorrowDt1.setSqdh(Util.null2String(rs.getString("b_sqdh")));
                    travelBorrowDt1.setSqsm(Util.null2String(rs.getString("b_sqsm")));
                    travelBorrowDt1.setCcksrq(Util.null2String(rs.getString("b_ccksrq")));
                    travelBorrowDt1.setCcjsrq(Util.null2String(rs.getString("b_ccjsrq")));
                    data1List.add(travelBorrowDt1);
                    //明细表2
                    TravelBorrowDt2 travelBorrowDt2 = new TravelBorrowDt2();
                    travelBorrowDt2.setFkjlnm(Util.null2String(rs.getString("c_fkjlnm")));
                    travelBorrowDt2.setBzdnm(Util.null2String(rs.getString("c_bzdnm")));
                    travelBorrowDt2.setZjjhbh(Util.null2String(rs.getString("c_zjjhbh")));
                    travelBorrowDt2.setZffsbh(Util.null2String(rs.getString("c_zffsbh")));
                    travelBorrowDt2.setDfxz(Util.null2String(rs.getString("c_dfxz")));
                    travelBorrowDt2.setBzrdw(Util.null2String(rs.getString("c_bzrdw")));
                    travelBorrowDt2.setSkzhm(Util.null2String(rs.getString("c_skzhm")));
                    travelBorrowDt2.setFkje(Util.null2String(rs.getString("c_fkje")));
                    travelBorrowDt2.setYxzh(Util.null2String(rs.getString("c_yxzh")));
                    travelBorrowDt2.setKhyx(Util.null2String(rs.getString("c_khyx")));
                    travelBorrowDt2.setZfsm(Util.null2String(rs.getString("c_zfsm")));
                    travelBorrowDt2.setZt(Util.null2String(rs.getString("c_zt")));
                    travelBorrowDt2.setFkhbbh(Util.null2String(rs.getString("c_fkhbbh")));
                    data2List.add(travelBorrowDt2);
                    //明细表3
                    TravelBorrowDt3 travelBorrowDt3 = new TravelBorrowDt3();
                    travelBorrowDt3.setJkdnm(Util.null2String(rs.getString("d_jkdnm")));
                    travelBorrowDt3.setSpjd(Util.null2String(rs.getString("d_spjd")));
                    travelBorrowDt3.setSpr(Util.null2String(rs.getString("d_spr")));
                    travelBorrowDt3.setSpnr(Util.null2String(rs.getString("d_spnr")));
                    travelBorrowDt3.setSpsj(Util.null2String(rs.getString("d_spsj")));
                    data3List.add(travelBorrowDt3);
                }
                datasList.add(dataList);
                datasList.add(data1List);
                datasList.add(data2List);
                datasList.add(data3List);
                exportDatas.put(type, datasList);
            }

            if ("Invoice".equals(type)) {//发票
                tableName = "uf_LC_fpxx";
                String acqDataSql = "select a.* from " + tableName + " a where a.id in (" + dataIds + ")";
                bb.writeLog("Invoice acqDataSql: " + acqDataSql);
                List<List<?>> datasList = new ArrayList<>();
                rs.executeQuery(acqDataSql);
                List dataList = new ArrayList<>();
                while (rs.next()) {
                    //主表
                    Invoice invoice = new Invoice();
                    invoice.setFpzj(Util.null2String(rs.getString("fpzj")));
                    invoice.setFplxid(Util.null2String(rs.getString("fplxid")));
                    invoice.setFplxbh(Util.null2String(rs.getString("fplxbh")));
                    invoice.setFpzlbh(Util.null2String(rs.getString("fpzlbh")));
                    invoice.setGmfmc(Util.null2String(rs.getString("gmfmc")));
                    invoice.setGmfxxnsrsbh(Util.null2String(rs.getString("gmfxxnsrsbh")));
                    invoice.setGmfxxdz(Util.null2String(rs.getString("gmfxxdz")));
                    invoice.setGmfxxdh(Util.null2String(rs.getString("gmfxxdh")));
                    invoice.setGmfxxkhx(Util.null2String(rs.getString("gmfxxkhx")));
                    invoice.setGmfxxkhxzh(Util.null2String(rs.getString("gmfxxkhxzh")));
                    invoice.setXsfmc(Util.null2String(rs.getString("xsfmc")));
                    invoice.setXsfxxnssbh(Util.null2String(rs.getString("xsfxxnssbh")));
                    invoice.setXsfdz(Util.null2String(rs.getString("xsfdz")));
                    invoice.setXsfdh(Util.null2String(rs.getString("xsfdh")));
                    invoice.setXsfkhyx(Util.null2String(rs.getString("xsfkhyx")));
                    invoice.setXsfkhxzh(Util.null2String(rs.getString("xsfkhxzh")));
                    invoice.setXym(Util.null2String(rs.getString("xym")));
                    invoice.setFphm(Util.null2String(rs.getString("fphm")));
                    invoice.setFpdm(Util.null2String(rs.getString("fpdm")));
                    invoice.setFprq(Util.null2String(rs.getString("fprq")));
                    invoice.setFpje(Util.null2String(rs.getString("fpje")));
                    invoice.setBhse(Util.null2String(rs.getString("bhse")));
                    invoice.setSe(Util.null2String(rs.getString("se")));
                    invoice.setBz(Util.null2String(rs.getString("bz")));
                    invoice.setFpbq(Util.null2String(rs.getString("fpbq")));
                    invoice.setFpfl(Util.null2String(rs.getString("fpfl")));
                    invoice.setFpflmc(Util.null2String(rs.getString("fpflmc")));
                    invoice.setFpnr(Util.null2String(rs.getString("fpnr")));
                    invoice.setYzzt(Util.null2String(rs.getString("yzzt")));
                    invoice.setBxzt(Util.null2String(rs.getString("bxzt")));
                    invoice.setZh(Util.null2String(rs.getString("zh")));
                    invoice.setDwbh(Util.null2String(rs.getString("dwbh")));
                    invoice.setYgbh(Util.null2String(rs.getString("ygbh")));
                    invoice.setWjlx(Util.null2String(rs.getString("wjlx")));
                    invoice.setCjsj(Util.null2String(rs.getString("cjsj")));
                    invoice.setCjr(Util.null2String(rs.getString("cjr")));
                    invoice.setZhxgsj(Util.null2String(rs.getString("zhxgsj")));
                    invoice.setZhxgr(Util.null2String(rs.getString("zhxgr")));
                    invoice.setYxlj(Util.null2String(rs.getString("yxlj")));
                    invoice.setSfzy(Util.null2String(rs.getString("sfzy")));
                    invoice.setZyrbh(Util.null2String(rs.getString("zyrbh")));

                    dataList.add(invoice);

                    datasList.add(dataList);
                }
                exportDatas.put(type, datasList);
            }
            if ("TravelReimbur".equals(type)) {//差旅报销
                tableName = "uf_OA_clbxd";
//                String acqDataSql = "select a.*, b.*, c. * ,d.*, e.*, f.*, g.*, h.* from " + tableName + " a " +
                String acqDataSql = "select " +
                        " a.id AS a_id,  \n" +
                        "a.requestid AS a_requestid,  \n" +
                        "a.djmc AS a_djmc,  \n" +
                        "a.djbh AS a_djbh,  \n" +
                        "a.dwbh AS a_dwbh,  \n" +
                        "a.bmbh AS a_bmbh,  \n" +
                        "a.djzt AS a_djzt,  \n" +
                        "a.bxrybh AS a_bxrybh,  \n" +
                        "a.ryzw AS a_ryzw,  \n" +
                        "a.ryzwbh AS a_ryzwbh,  \n" +
                        "a.ryzjid AS a_ryzjid,  \n" +
                        "a.ryzj AS a_ryzj,  \n" +
                        "a.cclx AS a_cclx,  \n" +
                        "a.ccdd AS a_ccdd,  \n" +
                        "a.ccksrq AS a_ccksrq,  \n" +
                        "a.ccjsrq AS a_ccjsrq,  \n" +
                        "a.ccts AS a_ccts,  \n" +
                        "a.xmmc AS a_xmmc,  \n" +
                        "a.hsxmlb AS a_hsxmlb,  \n" +
                        "a.kdkse AS a_kdkse,  \n" +
                        "a.fjzs AS a_fjzs,  \n" +
                        "a.lxdh AS a_lxdh,  \n" +
                        "a.bzje AS a_bzje,  \n" +
                        "a.fyrq AS a_fyrq,  \n" +
                        "a.sfczcbfy AS a_sfczcbfy,  \n" +
                        "a.ccsy AS a_ccsy,  \n" +
                        "a.sbje AS a_sbje,  \n" +
                        "a.sfje AS a_sfje,  \n" +
                        "a.jhje AS a_jhje,  \n" +
                        "a.fyxmnm AS a_fyxmnm,  \n" +
                        "a.zdrbh AS a_zdrbh,  \n" +
                        "a.sfwt AS a_sfwt,  \n" +
                        "a.str AS a_str,  \n" +
                        "a.formmodeid AS a_formmodeid,  \n" +
                        "a.modedatacreater AS a_modedatacreater,  \n" +
                        "a.modedatacreatertype AS a_modedatacreatertype,  \n" +
                        "a.modedatacreatedate AS a_modedatacreatedate,  \n" +
                        "a.modedatacreatetime AS a_modedatacreatetime,  \n" +
                        "a.modedatamodifier AS a_modedatamodifier,  \n" +
                        "a.modedatamodifydatetime AS a_modedatamodifydatetime,  \n" +
                        "a.form_biz_id AS a_form_biz_id,  \n" +
                        "a.modeuuid AS a_modeuuid,  \n" +
                        "  \n" +
                        "b.id AS b_id,  \n" +
                        "b.mainid AS b_mainid,  \n" +
                        "b.bxdnm AS b_bxdnm,  \n" +
                        "b.cfcs AS b_cfcs,  \n" +
                        "b.cfrq AS b_cfrq,  \n" +
                        "b.jtgj AS b_jtgj,  \n" +
                        "b.zxdj AS b_zxdj,  \n" +
                        "b.cchbc AS b_cchbc,  \n" +
                        "b.jpzk AS b_jpzk,  \n" +
                        "b.ddcs AS b_ddcs,  \n" +
                        "b.ddrq AS b_ddrq,  \n" +
                        "b.ccts AS b_ccts,  \n" +
                        "b.ccf AS b_ccf,  \n" +
                        "b.zsfbz AS b_zsfbz,  \n" +
                        "b.zsts AS b_zsts,  \n" +
                        "b.zsf AS b_zsf,  \n" +
                        "b.zsfsfcb AS b_zsfsfcb,  \n" +
                        "b.zscbsm AS b_zscbsm,  \n" +
                        "b.bxjhsjcf AS b_bxjhsjcf,  \n" +
                        "b.qtcbfy AS b_qtcbfy,  \n" +
                        "b.cbfysm AS b_cbfysm,  \n" +
                        "b.bzje AS b_bzje,  \n" +
                        "b.bxje AS b_bxje,  \n" +
                        "b.sfczcbfy2 AS b_sfczcbfy2,  \n" +
                        "  \n" +
                        "c.id AS c_id,  \n" +
                        "c.mainid AS c_mainid,  \n" +
                        "c.bxdid AS c_bxdid,  \n" +
                        "c.ftdwbh AS c_ftdwbh,  \n" +
                        "c.ftbmbh AS c_ftbmbh,  \n" +
                        "c.fyxm AS c_fyxm,  \n" +
                        "c.fyxmbh AS c_fyxmbh,  \n" +
                        "c.ftje AS c_ftje,  \n" +
                        "c.ftsm AS c_ftsm,  \n" +
                        "c.fph AS c_fph," +
                        "d.id AS d_id,  \n" +
                        "d.mainid AS d_mainid,  \n" +
                        "d.bxnm AS d_bxnm,  \n" +
                        "d.sqdjbh AS d_sqdjbh,  \n" +
                        "d.ccksrq AS d_ccksrq,  \n" +
                        "d.ccjsrq AS d_ccjsrq,  \n" +
                        "  \n" +
                        "e.id AS e_id,  \n" +
                        "e.mainid AS e_mainid,  \n" +
                        "e.hxdjnm AS e_hxdjnm,  \n" +
                        "e.jkrq AS e_jkrq,  \n" +
                        "e.djbh AS e_djbh,  \n" +
                        "e.jklx AS e_jklx,  \n" +
                        "e.fyxm AS e_fyxm,  \n" +
                        "e.jksm AS e_jksm,  \n" +
                        "e.jkje AS e_jkje,  \n" +
                        "e.zthk AS e_zthk,  \n" +
                        "e.yhk AS e_yhk,  \n" +
                        "e.hxje AS e_hxje,  \n" +
                        "e.xjhk AS e_xjhk,  \n" +
                        "e.qk AS e_qk,  \n" +
                        "  \n" +
                        "f.id AS f_id,  \n" +
                        "f.mainid AS f_mainid,  \n" +
                        "f.fkjlnm AS f_fkjlnm,  \n" +
                        "f.bzdnm AS f_bzdnm,  \n" +
                        "f.zjjhbh AS f_zjjhbh,  \n" +
                        "f.zjjhjsxz AS f_zjjhjsxz,  \n" +
                        "f.zffsbh AS f_zffsbh,  \n" +
                        "f.dfxz AS f_dfxz,  \n" +
                        "f.dwlb AS f_dwlb,  \n" +
                        "f.bzrdw AS f_bzrdw,  \n" +
                        "f.fkhbbh AS f_fkhbbh,  \n" +
                        "f.skzhm AS f_skzhm,  \n" +
                        "f.fkje AS f_fkje,  \n" +
                        "f.khyx AS f_khyx,  \n" +
                        "f.yxzh AS f_yxzh,  \n" +
                        "f.ssf AS f_ssf,  \n" +
                        "f.scs AS f_scs,  \n" +
                        "f.fksm AS f_fksm,  \n" +
                        "f.zt AS f_zt,  \n" +
                        "f.skyxlxh AS f_skyxlxh,  \n" +
                        "f.gssfdf AS f_gssfdf,  \n" +
                        "f.gsdf AS f_gsdf,  \n" +
                        "  \n" +
                        "g.id AS g_id,  \n" +
                        "g.mainid AS g_mainid,  \n" +
                        "g.bxdid AS g_bxdid,  \n" +
                        "g.spjd AS g_spjd,  \n" +
                        "g.sprbh AS g_sprbh,  \n" +
                        "g.spnr AS g_spnr,  \n" +
                        "g.spsj AS g_spsj,  \n" +
                        "  \n" +
                        "h.id AS h_id,  \n" +
                        "h.mainid AS h_mainid,  \n" +
                        "h.wjid AS h_wjid,  \n" +
                        "h.djnm AS h_djnm,  \n" +
                        "h.wjmc AS h_wjmc,  \n" +
                        "h.wjlx AS h_wjlx,  \n" +
                        "h.wjdx AS h_wjdx,  \n" +
                        "h.wjcclj AS h_wjcclj,  \n" +
                        "h.djbh AS h_djbh" +
                        " from " + tableName + " a " +
                        " left join " + tableName + "_dt1 b" +
                        " on b.mainid = a.id " +
                        " left join " + tableName + "_dt2 c" +
                        " on c.mainid = a.id " +
                        " left join " + tableName + "_dt3 d" +
                        " on d.mainid = a.id " +
                        " left join " + tableName + "_dt4 e" +
                        " on e.mainid = a.id " +
                        " left join " + tableName + "_dt5 f" +
                        " on f.mainid = a.id " +
                        " left join " + tableName + "_dt6 g" +
                        " on g.mainid = a.id " +
                        " left join " + tableName + "_dt7 h" +
                        " on h.mainid = a.id " +
                        "where a.id in (" + dataIds + ")";
                bb.writeLog("TravelReimbur acqDataSql: " + acqDataSql);
                List<List<?>> datasList = new ArrayList<>();
                rs.executeQuery(acqDataSql);
                List dataList = new ArrayList<>();
                List data1List = new ArrayList<>();
                List data2List = new ArrayList<>();
                List data3List = new ArrayList<>();
                List data4List = new ArrayList<>();
                List data5List = new ArrayList<>();
                List data6List = new ArrayList<>();
                List data7List = new ArrayList<>();
                while (rs.next()) {
                    //主表
                    TravelReimbur travelReimbur = new TravelReimbur();
                    travelReimbur.setDjmc(Util.null2String(rs.getString("a_djmc")));
                    travelReimbur.setDjbh(Util.null2String(rs.getString("a_djbh")));
                    travelReimbur.setDwbh(Util.null2String(rs.getString("a_dwbh")));
                    travelReimbur.setBmbh(Util.null2String(rs.getString("a_bmbh")));
                    travelReimbur.setDjzt(Util.null2String(rs.getString("a_djzt")));
                    travelReimbur.setBxrybh(Util.null2String(rs.getString("a_bxrybh")));
                    travelReimbur.setRyzw(Util.null2String(rs.getString("a_ryzw")));
                    travelReimbur.setRyzwbh(Util.null2String(rs.getString("a_ryzwbh")));
                    travelReimbur.setRyzjid(Util.null2String(rs.getString("a_ryzjid")));
                    travelReimbur.setRyzj(Util.null2String(rs.getString("a_ryzj")));
                    travelReimbur.setCclx(Util.null2String(rs.getString("a_cclx")));
                    travelReimbur.setCcdd(Util.null2String(rs.getString("a_ccdd")));
                    travelReimbur.setCcksrq(Util.null2String(rs.getString("a_ccksrq")));
                    travelReimbur.setCcjsrq(Util.null2String(rs.getString("a_ccjsrq")));
                    travelReimbur.setCcts(Util.null2String(rs.getString("a_ccts")));
                    travelReimbur.setXmmc(Util.null2String(rs.getString("a_xmmc")));
                    travelReimbur.setHsxmlb(Util.null2String(rs.getString("a_hsxmlb")));
                    travelReimbur.setKdkse(Util.null2String(rs.getString("a_kdkse")));
                    travelReimbur.setFjzs(Util.null2String(rs.getString("a_fjzs")));
                    travelReimbur.setLxdh(Util.null2String(rs.getString("a_lxdh")));
                    travelReimbur.setBzje(Util.null2String(rs.getString("a_bzje")));
                    travelReimbur.setFyrq(Util.null2String(rs.getString("a_fyrq")));
                    travelReimbur.setSfczcbfy(Util.null2String(rs.getString("a_sfczcbfy")));
                    travelReimbur.setCcsy(Util.null2String(rs.getString("a_ccsy")));
                    travelReimbur.setSbje(Util.null2String(rs.getString("a_sbje")));
                    travelReimbur.setSfje(Util.null2String(rs.getString("a_sfje")));
                    travelReimbur.setJhje(Util.null2String(rs.getString("a_jhje")));
                    travelReimbur.setFyxmnm(Util.null2String(rs.getString("a_fyxmnm")));
                    travelReimbur.setZdrbh(Util.null2String(rs.getString("a_zdrbh")));
                    travelReimbur.setSfwt(Util.null2String(rs.getString("a_sfwt")));
                    travelReimbur.setStr(Util.null2String(rs.getString("a_str")));
                    dataList.add(travelReimbur);
                    //明细表1
                    TravelReimburDt1 travelReimburDt1 = new TravelReimburDt1();
                    travelReimburDt1.setBxdnm(Util.null2String(rs.getString("b_bxdnm")));
                    travelReimburDt1.setCfcs(Util.null2String(rs.getString("b_cfcs")));
                    travelReimburDt1.setCfrq(Util.null2String(rs.getString("b_cfrq")));
                    travelReimburDt1.setJtgj(Util.null2String(rs.getString("b_jtgj")));
                    travelReimburDt1.setZxdj(Util.null2String(rs.getString("b_zxdj")));
                    travelReimburDt1.setCchbc(Util.null2String(rs.getString("b_cchbc")));
                    travelReimburDt1.setJpzk(Util.null2String(rs.getString("b_jpzk")));
                    travelReimburDt1.setDdcs(Util.null2String(rs.getString("b_ddcs")));
                    travelReimburDt1.setDdrq(Util.null2String(rs.getString("b_ddrq")));
                    travelReimburDt1.setCcts(Util.null2String(rs.getString("b_ccts")));
                    travelReimburDt1.setCcf(Util.null2String(rs.getString("b_ccf")));
                    travelReimburDt1.setZsfbz(Util.null2String(rs.getString("b_zsfbz")));
                    travelReimburDt1.setZsts(Util.null2String(rs.getString("b_zsts")));
                    travelReimburDt1.setZsf(Util.null2String(rs.getString("b_zsf")));
                    travelReimburDt1.setZsfsfcb(Util.null2String(rs.getString("b_zsfsfcb")));
                    travelReimburDt1.setZscbsm(Util.null2String(rs.getString("b_zscbsm")));
                    travelReimburDt1.setBxjhsjcf(Util.null2String(rs.getString("b_bxjhsjcf")));
                    travelReimburDt1.setQtcbfy(Util.null2String(rs.getString("b_qtcbfy")));
                    travelReimburDt1.setCbfysm(Util.null2String(rs.getString("b_cbfysm")));
                    travelReimburDt1.setBzje(Util.null2String(rs.getString("b_bzje")));
                    travelReimburDt1.setBxje(Util.null2String(rs.getString("b_bxje")));
                    travelReimburDt1.setSfczcbfy2(Util.null2String(rs.getString("b_sfczcbfy2")));
                    data1List.add(travelReimburDt1);
                    //明细表2
                    TravelReimburDt2 travelReimburDt2 = new TravelReimburDt2();
                    travelReimburDt2.setBxdid(Util.null2String(rs.getString("c_bxdid")));
                    travelReimburDt2.setFtdwbh(Util.null2String(rs.getString("c_ftdwbh")));
                    travelReimburDt2.setFtbmbh(Util.null2String(rs.getString("c_ftbmbh")));
                    travelReimburDt2.setFyxm(Util.null2String(rs.getString("c_fyxm")));
                    travelReimburDt2.setFyxmbh(Util.null2String(rs.getString("c_fyxmbh")));
                    travelReimburDt2.setFtje(Util.null2String(rs.getString("c_ftje")));
                    travelReimburDt2.setFtsm(Util.null2String(rs.getString("c_ftsm")));
                    travelReimburDt2.setFph(Util.null2String(rs.getString("c_fph")));
                    data2List.add(travelReimburDt2);
                    //明细表3
                    TravelReimburDt3 travelReimburDt3 = new TravelReimburDt3();
                    travelReimburDt3.setBxnm(Util.null2String(rs.getString("d_bxnm")));
                    travelReimburDt3.setSqdjbh(Util.null2String(rs.getString("d_sqdjbh")));
                    travelReimburDt3.setCcksrq(Util.null2String(rs.getString("d_ccksrq")));
                    travelReimburDt3.setCcjsrq(Util.null2String(rs.getString("d_ccjsrq")));
                    data3List.add(travelReimburDt3);
                    //明细表4
                    TravelReimburDt4 travelReimburDt4 = new TravelReimburDt4();
                    travelReimburDt4.setHxdjnm(Util.null2String(rs.getString("e_hxdjnm")));
                    travelReimburDt4.setJkrq(Util.null2String(rs.getString("e_jkrq")));
                    travelReimburDt4.setDjbh(Util.null2String(rs.getString("e_djbh")));
                    travelReimburDt4.setJklx(Util.null2String(rs.getString("e_jklx")));
                    travelReimburDt4.setFyxm(Util.null2String(rs.getString("e_fyxm")));
                    travelReimburDt4.setJksm(Util.null2String(rs.getString("e_jksm")));
                    travelReimburDt4.setJkje(Util.null2String(rs.getString("e_jkje")));
                    travelReimburDt4.setZthk(Util.null2String(rs.getString("e_zthk")));
                    travelReimburDt4.setYhk(Util.null2String(rs.getString("e_yhk")));
                    travelReimburDt4.setHxje(Util.null2String(rs.getString("e_hxje")));
                    travelReimburDt4.setXjhk(Util.null2String(rs.getString("e_xjhk")));
                    travelReimburDt4.setQk(Util.null2String(rs.getString("e_qk")));
                    data4List.add(travelReimburDt4);
                    //明细表5
                    TravelReimburDt5 travelReimburDt5 = new TravelReimburDt5();
                    travelReimburDt5.setFkjlnm(Util.null2String(rs.getString("f_fkjlnm")));
                    travelReimburDt5.setBzdnm(Util.null2String(rs.getString("f_bzdnm")));
                    travelReimburDt5.setZjjhbh(Util.null2String(rs.getString("f_zjjhbh")));
                    travelReimburDt5.setZjjhjsxz(Util.null2String(rs.getString("f_zjjhjsxz")));
                    travelReimburDt5.setZffsbh(Util.null2String(rs.getString("f_zffsbh")));
                    travelReimburDt5.setDfxz(Util.null2String(rs.getString("f_dfxz")));
                    travelReimburDt5.setDwlb(Util.null2String(rs.getString("f_dwlb")));
                    travelReimburDt5.setBzrdw(Util.null2String(rs.getString("f_bzrdw")));
                    travelReimburDt5.setFkhbbh(Util.null2String(rs.getString("f_fkhbbh")));
                    travelReimburDt5.setSkzhm(Util.null2String(rs.getString("f_skzhm")));
                    travelReimburDt5.setFkje(Util.null2String(rs.getString("f_fkje")));
                    travelReimburDt5.setKhyx(Util.null2String(rs.getString("f_khyx")));
                    travelReimburDt5.setYxzh(Util.null2String(rs.getString("f_yxzh")));
                    travelReimburDt5.setSsf(Util.null2String(rs.getString("f_ssf")));
                    travelReimburDt5.setScs(Util.null2String(rs.getString("f_scs")));
                    travelReimburDt5.setFksm(Util.null2String(rs.getString("f_fksm")));
                    travelReimburDt5.setZt(Util.null2String(rs.getString("f_zt")));
                    travelReimburDt5.setSkyxlxh(Util.null2String(rs.getString("f_skyxlxh")));
                    travelReimburDt5.setGssfdf(Util.null2String(rs.getString("f_gssfdf")));
                    travelReimburDt5.setGsdf(Util.null2String(rs.getString("f_gsdf")));
                    data5List.add(travelReimburDt5);
                    //明细表6
                    TravelReimburDt6 travelReimburDt6 = new TravelReimburDt6();
                    travelReimburDt6.setBxdid(Util.null2String(rs.getString("g_bxdid")));
                    travelReimburDt6.setSpjd(Util.null2String(rs.getString("g_spjd")));
                    travelReimburDt6.setSprbh(Util.null2String(rs.getString("g_sprbh")));
                    travelReimburDt6.setSpnr(Util.null2String(rs.getString("g_spnr")));
                    travelReimburDt6.setSpsj(Util.null2String(rs.getString("g_spsj")));
                    data6List.add(travelReimburDt6);
                    //明细表7
                    TravelReimburDt7 travelReimburDt7 = new TravelReimburDt7();
                    travelReimburDt7.setWjid(Util.null2String(rs.getString("h_wjid")));
                    travelReimburDt7.setDjnm(Util.null2String(rs.getString("h_djnm")));
                    travelReimburDt7.setWjmc(Util.null2String(rs.getString("h_wjmc")));
                    travelReimburDt7.setWjlx(Util.null2String(rs.getString("h_wjlx")));
                    travelReimburDt7.setWjdx(Util.null2String(rs.getString("h_wjdx")));
                    travelReimburDt7.setWjcclj(Util.null2String(rs.getString("h_wjcclj")));
                    data7List.add(travelReimburDt7);
                }
                datasList.add(dataList);
                datasList.add(data1List);
                datasList.add(data2List);
                datasList.add(data3List);
                datasList.add(data4List);
                datasList.add(data5List);
                datasList.add(data6List);
                datasList.add(data7List);
                exportDatas.put(type, datasList);
            }
            bb.writeLog("exportDatas: " + JSONObject.toJSONString(exportDatas));

//            SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
//            String fileName="/opt/weaver/ecology/filesystem/ebusecexport/"+ "差旅借款单" + sdf.format(new Date()) + ".xlsx";
            exportExcelFile(outPath, fileName, exportDatas);
            result = true;
        }catch (Exception e) {
            bb.writeLog("WorkflowExcelDataCmd Exception: " + e);

        }

        return result;

    }

    public void exportExcelFile(String outPath, String fileName, Map<String, List<List<?>> > exportDatas) {

        ExcelWriter excelWriter = EasyExcel.write(outPath + fileName + ".xlsx").build();

        for (String key : exportDatas.keySet()) {
            WriteSheet writeSheet = new WriteSheet();
            List<List<?>> tempList = exportDatas.get(key);
            int i = 0;
            for (List<?> tl: tempList) {
                //这里 需要指定写用哪个class去写
                writeSheet = EasyExcel.writerSheet(i, "第" + i + "个sheet页").head(tl.get(0).getClass()).build();
                excelWriter.write(tl, writeSheet);
                i++;
            }
        }

        //千万别忘记finish 会帮忙关闭流
        excelWriter.finish();
    }

}
